/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_TIPOINSU                                                 */
/* Tabela : TIPOINSU                                                          */
/*                                                                            */
/* Criao:                                                                   */
/* 21/04/2007 - Ronald Reis                                                   */
/*                                                                            */
/******************************************************************************/

CREATE OR REPLACE TRIGGER DTULTATU_TIPOINSU
BEFORE INSERT OR UPDATE OR DELETE
ON TIPOINSU FOR EACH ROW

BEGIN
   IF INSERTING THEN
      :NEW.DTULTATUTINS := SYSDATE;
   END IF;
   IF UPDATING THEN
      IF (NVL(:OLD.CDTIPOINSU,0) <> NVL(:NEW.CDTIPOINSU,0)) OR
         (NVL(:OLD.NMTIPOINSU,0) <> NVL(:NEW.NMTIPOINSU,0)) THEN
         :NEW.DTULTATUTINS := SYSDATE;
      END IF;
   END IF;
   IF DELETING THEN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
                       VALUES ('TIPOINSU', '', 'CDTIPOINSU='||:OLD.CDTIPOINSU||';', SYSDATE);
   END IF;
END;
/

ALTER TABLE TIPOINSU MODIFY DTULTATUTINS DEFAULT SYSDATE
/

-- VERSAO --
BEGIN ATUVEROBJ('DTULTATU_TIPOINSU','4.11.134'); END;
/
