/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_LOTE                                                     */
/* Tabela : LOTE                                                              */
/*                                                                            */
/* Criao:                                                                   */
/* 18/02/2003 - Luiz Otvio de Souza                                          */
/*                                                                            */
/******************************************************************************/

CREATE OR REPLACE TRIGGER DTULTATU_LOTE
BEFORE INSERT OR UPDATE OR DELETE
ON LOTE FOR EACH ROW

BEGIN
   IF INSERTING THEN
      :NEW.DTULTATULOTE := SYSDATE;
   END IF;
   IF UPDATING THEN
      IF (NVL(:OLD.CDFILIAL,0)   <> NVL(:NEW.CDFILIAL,0))   OR
         (NVL(:OLD.NRLOTEESTQ,0) <> NVL(:NEW.NRLOTEESTQ,0)) OR
         (NVL(:OLD.NRSUBLOTE,0)  <> NVL(:NEW.NRSUBLOTE,0))  OR
         (NVL(:OLD.CDPRODUTO,0)  <> NVL(:NEW.CDPRODUTO,0)) THEN
         :NEW.DTULTATULOTE := SYSDATE;
      END IF;
   END IF;
   IF DELETING THEN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
                       VALUES ('LOTE', '', 'CDFILIAL='||:OLD.CDFILIAL||';NRLOTEESTQ='||:OLD.NRLOTEESTQ||';NRSUBLOTE='||:OLD.NRSUBLOTE||';CDPRODUTO='||:OLD.CDPRODUTO||';', SYSDATE);
   END IF;
END;
/

ALTER TABLE LOTE MODIFY DTULTATULOTE DEFAULT SYSDATE
/
